;----------------------------------------------------------------------------
;				NES Startup
;					Copyright (C) 2007, Tekepen
;----------------------------------------------------------------------------
.setcpu		"6502"
.autoimport	on
.IMPORTZP	sp

; $B%5%&%s%IMQ(B
.segment "ZEROPAGE"
_SoundCounter:
.res 10,$00
_SoundIndex:
.res 10,$00
_RepeatCounter:
.res 5,$00
_Ctrl0Number:
.res 5,$00
_Ctrl1Number:
.res 5,$00
_FreqNumber:
.res 10,$00

.exportzp _SoundIndex,_SoundCounter,_RepeatCounter,_Ctrl0Number,_Ctrl1Number,_FreqNumber

; iNES$B%X%C%@(B
.segment "HEADER"
	.byte	$4E, $45, $53, $1A	; "NES" Header
	.byte	$02			; PRG-BANKS
	.byte	$11			; CHR-BANKS
	.byte	$31			; Vetrical Mirror / mapper low
	.byte	$00			; **** /mapper high
	.byte	$00, $00, $00, $00	; 
	.byte	$00, $00, $00, $00	; 

.segment "STARTUP"
; $B%j%;%C%H3d$j9~$_(B
.proc	Reset
	sei
waitVSync:
        lda $2002
        bpl waitVSync
        ldx #$00
        stx $2000
        stx $2001
        dex
        txs

        lda #$00
        tax
memoryClear:
	sta <$00,x
	sta $100,x
	sta $200,x
	sta $300,x
	sta $400,x
	sta $500,x
	sta $600,x
	sta $700,x
	inx
	bne memoryClear	

	; $B%=%U%H%&%'%"%9%?%C%/@_Dj(B
	lda	#$ff
	sta	sp
	lda	#$03
	sta	sp + 1

	jsr	_ResetProc

	cli

        rti
.endproc

; NMI
.proc   NMI
	
        jsr     _NMIProc

	nop
	nop
	nop

        rti
.endproc

;.include "mod_sound.asm"
;.include "songdata.asm"
;.include "sedata.asm"

.segment "DMCDATA"
.incbin "drum0.dmc"
.incbin "drum1.dmc"

.segment "VECINFO"
	.word	NMI
	.word	Reset
	.word	$0000

; $B%Q%?!<%s%F!<%V%k(B
.segment "CHARS0"
        .incbin "15puzzle.chr"
.segment "CHARS1"
        .incbin "15puzzle.chr"
.segment "CHARS2"
        .incbin "15puzzle.chr"
.segment "CHARS3"
        .incbin "15puzzle.chr"
.segment "CHARS4"
        .incbin "15puzzle.chr"
.segment "CHARS5"
        .incbin "15puzzle.chr"
.segment "CHARS6"
        .incbin "15puzzle.chr"
.segment "CHARS7"
        .incbin "15puzzle.chr"
.segment "CHARS8"
        .incbin "15puzzle.chr"
.segment "CHARS9"
        .incbin "15puzzle.chr"
.segment "CHARS10"
        .incbin "15puzzle.chr"
.segment "CHARS11"
        .incbin "15puzzle.chr"
.segment "CHARS12"
        .incbin "15puzzle.chr"
.segment "CHARS13"
        .incbin "15puzzle.chr"
.segment "CHARS14"
        .incbin "15puzzle.chr"
.segment "CHARS15"
        .incbin "15puzzle.chr"
.segment "CHARS16"
        .incbin "15puzzle.chr"
